<?php
declare(strict_types=1);

namespace FiloBlu\ExtMailChimp\Plugin;

use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Api\OrderManagementInterface;

class FixNullValuesBeforePlace
{
    /**
     * @var array
     */
    private $valuesToCheck;

    /**
     * @param array $valuesToCheck
     */
    public function __construct(array $valuesToCheck = [])
    {
        $this->valuesToCheck = $valuesToCheck;
    }

    /**
     * @param OrderManagementInterface $subject
     * @param OrderInterface $order
     * @return null
     */
    public function beforePlace(OrderManagementInterface $subject, OrderInterface $order)
    {
        foreach ($this->valuesToCheck as $column => $defaultValue) {
            if ($order->getData($column)) {
                continue;
            }
            $order->setData($column, $defaultValue);
        }
        return null;
    }
}
